<?
Header('Cache-Control: no-cache');
Header('Pragma: no-cache');

/*
+--------------------------------------------------
|				-::- ratings.php -::-
| -------------------------------------------------
|
|	Made by FOPT_Cloudberry (cloudberry@fopt-clan.de)
|	and Olympus_Hermes (currently retired from online gaming)
|	(c) Copyright FOPT_Cloudberry 2004
|	Website http://cloudmods.net
|
| -------------------------------------------------
|
|	Work began Fri, July 2nd 2004
|	Version 1.0
|	Enhanced by RaFaLLL (2007-2007), Gamepark, AoEIII, IGZ support
|
| -------------------------------------------------
*/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms available from CloudMods.
 *
 ***************************************************************************/
 
function log_event($text) {
	$fd = fopen("histo.txt", "a+");
	if ($fd == false) {
		echo "fail to write log<br>";
		return;
	}
	$buffer = time() . ": " . $text ."\n";
	fwrite($fd, $buffer);
	fclose($fd);
	/*error_log(time() . ": " . $text ."\n", 3, "ratings.log");*/
}

function log_histo($rating_file, $user, $rating, $nb_game) {
	if (isset($nb_game) == false)
		return;
	
	$fd = fopen($rating_file, "a+");
	if ($fd == false) {
		echo "fail to write log<br>";
		return;
	}
	$buffer = time() . ", $user, $rating, $nb_game\n";
	fwrite($fd, $buffer);
	fclose($fd);
}

// ~~ Array Initializations ~~
$sockets = Array();
$ret_done = Array();
$ret_data = Array();
$parsed_data = Array();

// ~~ Include necessary files ~~
include('functions.php');
include('template_engine.php');
include('players.php');

// ~~ Var init
$nb_new_rating = 0;

// ~~ Initialize the template engine ~~
$template = new Template('.');

// ~~ define
$refresh = 3600; // toutes les heures on rafraichi le cache

$tad = false;
$twc = false;
$aoe3 = false;
$gp = false;
$igz = false;
$tc = false;

if ($_GET["tad"] == 1) {
	$tad = true;
	$stat_file = 'stat_tad.txt';
	$template_file = "template_tad.html";
	$rating_file = "ratings_tad.txt";
}
else if ($_GET["twc"] == 1) {
	$twc = true;
	$stat_file = 'stat_twc.txt';
	$template_file = "template_twc.html";
	$rating_file = "ratings_twc.txt";
}
else if ($_GET["aoe3"] == 1) {
	$aoe3 = true;
	$stat_file = 'stat_aoe3.txt';
	$template_file = "template_aoe3.html";
	$rating_file = "ratings_aoe3.txt";
}
else if ($_GET["gp"] == 1) {
	$gp = true;
	$stat_file = 'stat_gp.txt';
	$template_file = "template_gp.html";
	$rating_file = "ratings_gp.txt";
}
else if ($_GET["igz"] == 1) {
	$igz = true;
	$stat_file = 'stat_igz.txt';
	$template_file = "template_igz.html";
	$rating_file = "ratings_igz.txt";
}
else {
	$tc = true;
	$stat_file = 'stat.txt';
	$template_file = "template.html";
	$rating_file = "ratings.txt";
}

if (file_exists($stat_file) && filesize($stat_file) > 0) {
	$is_cached = true;
	if (time() - filemtime($stat_file) > $refresh) {
		log_event("auto update because " . time() . "," . filemtime($stat_file));
		touch($stat_file);
		$cache = false;
	}
	else {
		log_event("use cache");
		$cache = true;
	}
}
else {
	log_event("================ No cache !!! ================");
	$is_cached = false;
	$cache = false;
}

if ($_POST["force"] == 1 || $_GET["force"] == 1) {
	log_event("force reinit cache");
	$cache = false; /* force le refresh */
	$force_update = true;
}

	
if ($_GET["top5"] == 1) {
	$top5 = true; /* cherche les 5 meilleurs */
	$template_file = "template_top5.html";
}
else if ($_GET["top5active"] == 1) {
	$top5active = true; /* cherche les 5 meilleurs joueurs actifs */
	$template_file = "template_top5.html";
	$cache = true; /* on utilise que le cache */
}
else if ($_GET["avrg"] == 1) {
	$average = true; /* cherche la moyenne By IronDuck je sais pas si c ncessaire en fait ^^*/
	$template_file = "template_avrg.html";
	$cache = true;
}

if ($tc == true) {
	$cache = true; /* on utilise que le cache car ZONE est mort :-( */
}

// ~~ Assign the template file ~~
$template->set_filenames(array(
	'template' => "$template_file" )
);

if ($cache == false) {

	if ($tad == true || $twc == true || $aoe3 == true) {

		if ($tad == true) {
			$nick = &$nick_tad;
			$game_id = 3;
		}
		else if ($twc == true) {
			$nick = &$nick_twc;
			$game_id = 2;
		}
		else {
			$nick = &$nick_aoe3;
			$game_id = 1;
		}
		$ch = curl_init();

		reset($nick);
		$nick_list = "";
		$pre = "";
		while (list($eso_nick, $wotc_nick) = each($nick)) {
			$nick_list .= $pre.$eso_nick;
			$pre = ";";
		}
		reset($nick);

		$url = "http://www.elorating.com";
		$path = "/ranking-services/ratingquery?name=$nick_list&mode=SP&laddertype=5&game=$game_id";
		curl_setopt ($ch, CURLOPT_URL, $url.$path);
		curl_setopt ($ch, CURLOPT_HEADER, 0);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);

		$rep = curl_exec ($ch);
		curl_close ($ch); 

		/*
		$handle = fopen("$url.$path", "r");
		$rep2 = fread($handle, 32*1024);
		fclose($handle);
		echo "REP2=$rep<br>";
		*/
		
		$p =& new xmlParser();
		$p->parse_string($rep);
		
		//print_r($p->output);
		
		$nb = count($p->output);
		
		for($i=0; $i < $nb; $i++) {
			if ($p->output[$i]['NAME'] == null)
				continue;
			$nb_players ++;
			$p1 = $parsed_data[$i]['nick'] = $p->output[$i]['NAME'];
			$parsed_data[$i]['wotc_nick'] = $nick[$p1];
			$parsed_data[$i]['rank'] = $p->output[$i]['LADDERID'];
			$parsed_data[$i]['rating'] = intval($p->output[$i]['RATE']);
			$parsed_data[$i]['wins'] = intval($p->output[$i]['WIN']);
			$parsed_data[$i]['losses'] = intval($p->output[$i]['LOSS']);
			$parsed_data[$i]['games'] = $parsed_data[$i]['wins'] + $parsed_data[$i]['losses'];
			$parsed_data[$i]['tie'] = 0;
			$parsed_data[$i]['incomp'] = 0;
			$parsed_data[$i]['streak'] = $p->output[$i]['STREAK'];
			$parsed_data[$i]['date'] = "-";

			if (intval($parsed_data[$i]['games']) != 0) {
				$parsed_data[$i]['winpercent'] = floor(($parsed_data[$i]['wins'] * 100) / $parsed_data[$i]['games'])."%";
			}
			else {
				$parsed_data[$i]['winpercent'] = '-';
			}
			$indirect[$parsed_data[$i]['nick']] = $i;
		}
	}
	else if ($tc == true) {
		// ~~ Open the sockets and prepare them for non-blocking! ~~
		$host = 'classic.zone.msn.com';
		$done = false;
		$i=0;
		$nb_players = count($nick_tc);
		while( !$done )
		{
			$p = trim($nick_tc[$i]);
			if (strlen($p) < 2) {
				/* bad nick */
				$nb_players = $i;
				break;
			}
			$sockets[$i] = fsockopen($host, 80, $errno, $errstr, 30);
			stream_set_blocking($sockets[$i], FALSE);
			$path = '/Profile/RatingsPlayer.asp?Players=2&Teams=&PlayerID=' . $p . '&TeamID=&pguest=1';
			fputs($sockets[$i],"GET $path HTTP/1.0\r\nHost: $host\r\n\r\n");
			$i ++;
		}

		// ~~ Grab the data from each profile simeltaneous, using the prepared sockets! ~~
		$done = false;
		while( !$done )
		{
			for( $i = 0; $i < $nb_players; $i++ ) 
			{
				if ($ret_done[$i] == 1) /* optimization by RaFaLLL */
				continue;

				if( !feof($sockets[$i]) ) 
				{
					if( $ret_data[$i] )
					{
						$ret_data[$i] .= fgets($sockets[$i], 8192);
					}
					else
					{
						$ret_data[$i] = fgets($sockets[$i], 8192);
					}
				}
				else
				{
					$ret_done[$i] = 1;
					fclose($sockets[$i]);
				}
			}
			$done = (array_sum($ret_done) == $nb_players);
		}

		log_event("Fetching info for $nb_players players");
		$error = 0;

		// ~~ Parse the obtained data ~~
		for( $i = 0; $i < $nb_players; $i++ )
		{
			if (strlen($ret_data[$i]) < 8000) {
				$error ++;
			}
			$ret_data[$i]= substr($ret_data[$i], 8000);
			//echo "data size=" . strlen($ret_data[$i]) ."<br>";
			$parsed_data[$i] = parse_profile($ret_data[$i]);
			$parsed_data[$i]['date'] = "-";
			$indirect[$parsed_data[$i]['nick']] = $i;
		}

		if ($error) {
			log_event("Nb error: $error ($nb_players players)");
			echo "Zone is unreachable";
			die;
		}
	}
	else if ($gp == true) {

		reset($nick_gp);
		
		// ~~ Open the sockets and prepare them for non-blocking! ~~
		$host = "www.gamepark.eu";
		$done = false;
		$i=0;
		$nb_players = count($nick_gp);
		while (list($wotc_nick, $gp_id) = each($nick_gp)) {
			$parsed_data[$i]['nick'] = $gp_id;
			$parsed_data[$i]['wotc_nick'] = $wotc_nick;

			$sockets[$i] = fsockopen($host, 80, $errno, $errstr, 30);
			stream_set_blocking($sockets[$i], FALSE);
			$path = "/en/AOE_Player.asp?id=$gp_id&p=170";

			//echo "PATH=$path, $wotc_nick, $gp_id, $i<br>";

			fputs($sockets[$i],"GET $path HTTP/1.0\r\nHost: $host\r\n\r\n");
			$i ++;
		}

		//echo "NB PL=$nb_players, $i<br>";

		// ~~ Grab the data from each profile simeltaneous, using the prepared sockets! ~~
		$done = false;
		while( !$done )
		{
			for( $i = 0; $i < $nb_players; $i++ ) 
			{
				if ($ret_done[$i] == 1) /* optimization by RaFaLLL */
				continue;

				if( !feof($sockets[$i]) ) 
				{
					if( $ret_data[$i] )
					{
						$ret_data[$i] .= fgets($sockets[$i], 8192);
					}
					else
					{
						$ret_data[$i] = fgets($sockets[$i], 8192);
					}
				}
				else
				{
					$ret_done[$i] = 1;
					fclose($sockets[$i]);
				}
			}
			$done = (array_sum($ret_done) == $nb_players);
		}

		log_event("Fetching info for $nb_players players");
		$error = 0;

		// ~~ Parse the obtained data ~~
		for( $i = 0; $i < $nb_players; $i++ )
		{
			if (strlen($ret_data[$i]) < 1000) {
				$error ++;
			}
			//echo "data size=" . strlen($ret_data[$i]) ."<br>";
			$gp_id = $parsed_data[$i]['nick'];
			$wotc_nick = $parsed_data[$i]['wotc_nick'];
			$parsed_data[$i] = parse_gp_profile($ret_data[$i]);
			$parsed_data[$i]['date'] = "-";
			$parsed_data[$i]['nick'] = $gp_id;
			$parsed_data[$i]['wotc_nick'] = $wotc_nick;
			$indirect[$parsed_data[$i]['nick']] = $i;
		}

		if ($error) {
			log_event("Nb error: $error ($nb_players players)");
			echo "GP is unreachable";
			die;
		}
	}
	else if ($igz == true) {

		reset($nick_igz);
		
		// ~~ Open the sockets and prepare them for non-blocking! ~~
		//$host = "igzones.com";
		$host = "87.106.68.85";
		$done = false;
		$i=0;
		$nb_players = count($nick_igz);
		while (list($wotc_nick, $igz_id) = each($nick_igz)) {
			$parsed_data[$i]['nick'] = $igz_id;
			$parsed_data[$i]['wotc_nick'] = $wotc_nick;

			$sockets[$i] = fsockopen($host, 80, $errno, $errstr, 30);
			stream_set_blocking($sockets[$i], FALSE);
			$path = "/user/$igz_id";

			//echo "PATH=$path, $wotc_nick, $igz_id, $i<br>";

			fputs($sockets[$i],"GET $path HTTP/1.0\r\nHost: $host\r\n\r\n");
			$i ++;
		}

		//echo "NB PL=$nb_players, $i<br>";

		// ~~ Grab the data from each profile simeltaneous, using the prepared sockets! ~~
		$done = false;
		while( !$done )
		{
			for( $i = 0; $i < $nb_players; $i++ ) 
			{
				if ($ret_done[$i] == 1) /* optimization by RaFaLLL */
				continue;

				if( !feof($sockets[$i]) ) 
				{
					if( $ret_data[$i] )
					{
						$ret_data[$i] .= fgets($sockets[$i], 8192);
					}
					else
					{
						$ret_data[$i] = fgets($sockets[$i], 8192);
					}
				}
				else
				{
					$ret_done[$i] = 1;
					fclose($sockets[$i]);
				}
			}
			$done = (array_sum($ret_done) == $nb_players);
		}

		log_event("Fetching info for $nb_players players");
		$error = 0;

		// ~~ Parse the obtained data ~~
		for( $i = 0; $i < $nb_players; $i++ )
		{
			if (strlen($ret_data[$i]) < 1000) {
				$error ++;
			}
			//echo "data size=" . strlen($ret_data[$i]) ."<br>";
			$igz_id = $parsed_data[$i]['nick'];
			$parsed_data[$i] = parse_igz_profile($ret_data[$i]);
			$parsed_data[$i]['nick'] = $igz_id;
			$indirect[$parsed_data[$i]['nick']] = $i;
		}

		if ($error) {
			log_event("Nb error: $error ($nb_players players)");
			echo "IGZ is unreachable";
			die;
		}
	}

	//print_r($parsed_data);

	/* 
	 * Recherche du rating max 
	 */

	$data = file($rating_file);

	//echo count($data) . "\n";

	foreach ($data as $line_num => $line) {
		$field = explode(',', $line); /* date, id, rate, nb_game */
		$pl = trim($field[1]);
		//echo "$pl, " . $field[0] . ", " . $field[2] . "<br>";
		$r = $rating[$pl]; /* $r vaut rien au 1er passage */
		if ($field[2] >= $r) {
			$rating[$pl] = $field[2]; 	/* rating max */
			$date[$pl] = $field[0];		/* date du rating max */
		}
			/* dernier match (date) */
		$last_date[$pl] = $field[0];	
			/* on note le dernier rate du joueur */
		$last_rate[$pl] = $field[2];
	}

	/*
	echo "<br>rating:<br>";
	print_r($rating);

	echo "<br>last_rate:<br>";
	print_r($last_rate);

	echo "<br>last_date:<br>";
	print_r($last_date);
	*/

	for( $i = 0; $i < $nb_players; $i++ ) 
	{
		$parsed_data[$i]['new'] = true;
	}

	$nb_new_rating  = 0;
	$nb_new_pl = 0;
	$nb_rate = count($rating);
	if ($nb_rate >0) {
	foreach ($rating as $pl => $rate) {
		$i = $indirect[$pl];
		if (isset($i) == false) /* on saute les anciens joueurs */
			continue;
		if ($igz == false)
			$parsed_data[$i]['date'] = $last_date[$pl];
		$parsed_data[$i]['max_rate'] = (int)$rate;
		$parsed_data[$i]['max_date'] = date("Y-m-j", $date[$pl]);
		$parsed_data[$i]['new'] = false;

		if ($last_rate[$pl] != intval($parsed_data[$i]['rating'])) { /* a faire sur l'evolution du nb de partie plutot XXX */
			if ($igz == false)
				$parsed_data[$i]['date'] = time();
			log_histo($rating_file, $pl, $parsed_data[$i]['rating'], $parsed_data[$i]['games']);
			$last_rate[$pl] = intval($parsed_data[$i]['rating']);
			if ($last_rate[$pl] > $rating[$pl]) {
				$rating[$pl] = $last_rate[$pl];
				$date[$pl] = $parsed_data[$i]['date'];
			}
			$nb_new_rating ++;
		}
	}
	}
	
	/* 
	 * Recherche des nouveaux joueurs ... 
	 */
	for( $i = 0; $i < $nb_players; $i++ ) 
	{
		if ($parsed_data[$i]['new'] == true) {
			if ($igz == false)
				$parsed_data[$i]['date'] = time();
			$parsed_data[$i]['max_rate'] = $parsed_data[$i]['rating'];
			$parsed_data[$i]['max_date'] = date("Y-m-j", $parsed_data[$i]['date']);
			log_histo($rating_file, $parsed_data[$i]['nick'], $parsed_data[$i]['rating'], $parsed_data[$i]['games']);
			$nb_new_pl ++;
		}
	}

	log_event("nb_player: $nb_players, nb_rate: $nb_rate, nb_new_rating: $nb_new_rating, new_player: $nb_new_pl)");

	/*  RaFaLLL : sauvegarde dans un cache du resultat
	* ATTENTION a proteger par un lock au cas ou en meme temps on le lit TODO XXX
	*
	*/

	$buffer = "";
	for( $i = 0; $i < $nb_players; $i++ ) 
	{
		if (strlen($parsed_data[$i]['nick']) < 2) /* on saute les anomalies */
		continue;
		$buffer .= $parsed_data[$i]['nick'] . ", ";
		$buffer .= $parsed_data[$i]['wotc_nick'] . ", ";
		$buffer .= $parsed_data[$i]['rank'] . ", ";
		$buffer .= $parsed_data[$i]['rating'] . ", ";
		$buffer .= $parsed_data[$i]['games'] . ", ";
		$buffer .= $parsed_data[$i]['wins'] . ", ";
		$buffer .= $parsed_data[$i]['losses'] . ", ";
		$buffer .= $parsed_data[$i]['ties'] . ", ";
		$buffer .= $parsed_data[$i]['incomp'] . ", ";
		$buffer .= $parsed_data[$i]['streak'] . ", ";
		if (intval($parsed_data[$i]['games']) == 0) {
			$parsed_data[$i]['date'] = "-";
		}
		$buffer .= $parsed_data[$i]['date'] . ",";
		$buffer .= $parsed_data[$i]['max_rate'] . ",";
		$buffer .= $parsed_data[$i]['max_date'] . ",\n";
	}
	if (file_exists($stat_file) && filesize($stat_file) > 0 && $is_cached == false) {
		log_event("=========== BUG ======= cache just be created. Do not overwrite");
	}
	else {
		$fp2 = fopen($stat_file, 'w+');
		fwrite($fp2,$buffer);
		fclose($fp2);
		log_event("Cache updated");
	}

	//echo "(request info)<br>";
}
else {
	//echo "(info cached)<br>";
	$lines = file($stat_file);
	foreach ($lines as $line_num => $line) {
		$parsed = explode(',',$line);
		$parsed_data[$line_num]['nick']   = $parsed[0];
		$parsed_data[$line_num]['wotc_nick']   = $parsed[1];
		$parsed_data[$line_num]['rank']   = (int)$parsed[2];
		$parsed_data[$line_num]['rating'] = (int)$parsed[3];
		$parsed_data[$line_num]['games']  = (int)$parsed[4];
		$parsed_data[$line_num]['wins']   = (int)$parsed[5];
		$parsed_data[$line_num]['losses'] = (int)$parsed[6];
		$parsed_data[$line_num]['ties']   = (int)$parsed[7];
		$parsed_data[$line_num]['incomp'] = (int)$parsed[8];
		$parsed_data[$line_num]['streak'] = (int)$parsed[9];
		if (intval($parsed_data[$line_num]['games']) != 0) {
			$parsed_data[$line_num]['winpercent'] = floor(($parsed_data[$line_num]['wins'] * 100) / $parsed_data[$line_num]['games'])."%";
		}
		else {
			$parsed_data[$line_num]['winpercent'] = '-';
		}

		if ($parsed_data[$line_num]['games'] == 0) 
			$parsed_data[$line_num]['date'] = 0;
		else
			$parsed_data[$line_num]['date'] = (int)$parsed[10];
		$parsed_data[$line_num]['max_rate'] = (int)$parsed[11];
		$parsed_data[$line_num]['max_date'] = $parsed[12];
	}
	$nb_players = $line_num + 1;
}

//sem_release($semaphor);

// ~~ Sort the player attributes on rating ~~
usort( $parsed_data, "sorter" ); 


$avrg = array(
	'rating' => 0,
	'max_rate' => 0, 
	'games' => 0,
	'wins' => 0,
	'losses' => 0,
	'ties' => 0,
	'incomp' => 0,
	'streak' => 0,
	'winpercent' => 0,
	'date' => 0,
);

if ($top5 == true)
	$nb_players = 5;

$number = 0;

// ~~ Put the data in the template blocks ~~
for( $i = 0; $i < $nb_players; $i++ )
{
	if(empty($parsed_data[$i]['nick']) )
		continue;

	if (intval($parsed_data[$i]['date']) == 0 || intval($parsed_data[$i]['games']) == 0) {
		$date = "-";
		$has_date = false;
	}
	else {
		$diff = time() - $parsed_data[$i]['date'];
		$date = round((time() - $parsed_data[$i]['date']) / (3600*24));
		$has_date = true;
	}

	if ($top5active == true) {
		if (($has_date == false) || ($date > 30))
			continue;
	}

	if ($top5 == true || $top5active == true || $tad == true || $twc == true || $aoe3 == true) {
		if ($aoe3 == true || $tad == true || $twc == true) {
			if (strstr($parsed_data[$i]['nick'], "WOTC_"))
				$nick = substr($parsed_data[$i]['nick'], 5);
			else
				$nick = $parsed_data[$i]['nick'];
		}
		else if ($gp == true || $igz == true) {
			$nick = $parsed_data[$i]['wotc_nick'];
		}
		else {
			$nick = $parsed_data[$i]['nick'];
		}
	}
	else if ($tc == true)
		$nick = '<a href="http://classic.zone.msn.com/Profile/RatingsPlayer.asp?Players=2&Teams=&PlayerID=' . $parsed_data[$i]['nick'] . '">' . $parsed_data[$i]['nick'] . '</a>';
	else if ($gp == true)
		$nick = '<a href="http://www.gamepark.eu/en/AOE_Player.asp?id=' . $parsed_data[$i]['nick'] . '&p=170">' . $parsed_data[$i]['wotc_nick'] . '</a>';
	else if ($igz == true)
		$nick = '<a href="http://igzones.com/user/' . $parsed_data[$i]['nick'] . '">' . "[WOTC]" . trim($parsed_data[$i]['wotc_nick']) . '</a>';

	$template->assign_block_vars('row', array(
		'WOTC_NICK' => $parsed_data[$i]['wotc_nick'],
		'NICK' => $nick,
		'RATING' => $parsed_data[$i]['rating'],
		'RANK' => $parsed_data[$i]['rank'],
		'GAMES' => $parsed_data[$i]['games'],
		'WINS' => $parsed_data[$i]['wins'],
		'LOSSES' => $parsed_data[$i]['losses'],
		'INCOMP' => $parsed_data[$i]['incomp'],
		'STREAK' => $parsed_data[$i]['streak'],
		'DATE' => $date,
		'CLASS' => give_class(),
		'WINPERCENT' => $parsed_data[$i]['winpercent'],
		'MAX_RATE' => $parsed_data[$i]['max_rate'],
		'MAX_DATE' => $parsed_data[$i]['max_date'])
	);
	
	if (intval($parsed_data[$i]['games']) != 0 )
	{
		$number++;
		$avrg['rating'] += $parsed_data[$i]['rating'];
		$avrg['games'] += $parsed_data[$i]['games'];
		$avrg['wins'] += $parsed_data[$i]['wins'];
		$avrg['losses'] += $parsed_data[$i]['losses'];
		$avrg['incomp'] += $parsed_data[$i]['incomp'];
		$avrg['streak'] += $parsed_data[$i]['streak'];
	}

	if ($top5active == true) {
		$nb_top5 ++;
		if ($nb_top5 == 5)
			break;
	}
}

if ($number == 0) {
	echo "Impossible de recuperer les ratings<br>";
	exit;
}

if (!($top5 == true || $top5active == true)) {
	$template->assign_vars(array(
	'RATING' => number_format($avrg['rating'] / $number, 0, '.', ''),
	'GAMES' => number_format($avrg['games'] / $number, 0, '.', ''),
	'WINS' => number_format($avrg['wins'] / $number, 0, '.', ''),
	'LOSSES' => number_format($avrg['losses'] / $number, 0, '.', ''),
	'INCOMP' => number_format($avrg['incomp'] / $number, 0, '.', ''),
	'STREAK' => number_format($avrg['streak'] / $number, 0, '.', ''),
	'WINPERCENT' => number_format(($avrg['wins'] / $avrg['games']) * 100, 0, '.', '') )
);
}


// ~~ Output the data to the template ~~
$template->pparse('template');

if (!($top5 == true || $top5active == true || $average == true || $tc == true)) {
	$path = $_SERVER["REQUEST_URI"];
	echo "<form action=\"$path\" method=\"POST\"><input type=\"hidden\" name=\"force\" value=\"1\"><input type=\"submit\" value=\"Force to refresh rating data\")></form>";
}

class xmlParser{
   var $xml_obj = null;
   var $output = array();
   var $attrs;
   var $data;
   var $nb;

   function xmlParser(){
       $this->xml_obj = xml_parser_create();
       $this->nb = 0;

       xml_set_object($this->xml_obj,$this);
       xml_set_character_data_handler($this->xml_obj, 'dataHandler');
       xml_set_element_handler($this->xml_obj, "startHandler", "endHandler");
   }

   function parse_string($str){
           if (!xml_parse($this->xml_obj, $str, true)) {
               die(sprintf("XML error: %s at line %d",
               xml_error_string(xml_get_error_code($this->xml_obj)),
               xml_get_current_line_number($this->xml_obj)));
               xml_parser_free($this->xml_obj);
           }
       return true;
   }
   function parse($path){
       if (!($fp = fopen($path, "r"))) {
           die("Cannot open XML data file: $path");
           return false;
       }

       while ($data = fread($fp, 4096)) {
           if (!xml_parse($this->xml_obj, $data, feof($fp))) {
               die(sprintf("XML error: %s at line %d",
               xml_error_string(xml_get_error_code($this->xml_obj)),
               xml_get_current_line_number($this->xml_obj)));
               xml_parser_free($this->xml_obj);
           }
       }

       return true;
   }

   function startHandler($parser, $name, $attribs){
       //echo "start=$name<br>";
       $this->data = null;
   }

   function dataHandler($parser, $data){
       if(!empty($data) && $data!="\n") {
	   $this->data .= $data;
           //echo "data=$data<br>";
       }
   }

   function endHandler($parser, $name){
	   //echo "end=$name<br>";
	   $this->output[$this->nb][$name] = $this->data;
	   if (strcasecmp($name, "PLAYERRATING") == 0)
	   	$this->nb ++;
   }
}


?>
